/*
 * Created on 13.09.2005
 *
 * TODO What for is this class?
 */
package de.wagner_ibw.iow.smx;


/**
 * @author Wagner.T
 *
 * TODO What for is this class?
 */
public class KeyMap {
	
	private String[][] label = new String[8][8];
	private int xs = 8;
	private int ys = 8;
	
	public KeyMap(String[][] map) {
		
		int x,y = 0;
		
		for(x = 0; x < map.length; x++) {
			for (y = 0; y < map[x].length; y++) {
				label[x][y] = map[x][y];
			}
		}
		xs = x--;
		ys = y--;
	
	}
	
	public String toString(){
		StringBuffer sb = new StringBuffer();
		sb.append("KeyMatrix[x=");
		sb.append(xs);
		sb.append(",y=");
		sb.append(ys);
		sb.append("]:\n");
		for(int x = 0; x < xs; x++) {
			for (int y = 0; y < ys; y++) {
				sb.append(label[x][y]+"\t");
			}
			sb.append("\n");
		}
		return sb.toString();
	}
	
	public String getKeyLabes(int[] event) {
		int x = -1;
		int y = -1;
		for( y = 0; y < ys; y++){
			if (event[y] != 0){
				if(event[y] == 0x01) x = 0;
				else if(event[y] == 0x02) x = 1;
				else if(event[y] == 0x04) x = 2;
				else if(event[y] == 0x08) x = 3;
				else if(event[y] == 0x10) x = 4;
				else if(event[y] == 0x20) x = 5;
				else if(event[y] == 0x40) x = 6;
				else x = 7;
				break;	//found
			}
		}
		if (x != -1 && y != -1) {
			String retLabel = label[x][y];
			if (retLabel == null) {
				retLabel = "no label defined";
			}
			/*deb*/System.out.println("found ("+x+","+y+"): "+ retLabel);
			return retLabel;
		}
		else {
			return "no key pressed";
		}
	}
	
	public static void main(String[] args) {
		String[][] myMap = {{"1","2","3"},
							{"4","5","6"}};
	//	String[][] myMap = {{"leer","oben","leer"},
	//						{"links","unten","rechts"}};
		int[] matrix = {0,0,0,0,0,0,0,0};
		
		KeyMap km = new KeyMap(myMap);
		System.out.println(km);
		
		matrix[0] = 0x01;
		matrix[1] = 0;
		matrix[2] = 0;
		System.out.println("1: "+km.getKeyLabes( matrix));
		
		matrix[0] = 0;
		matrix[1] = 0x01;
		matrix[2] = 0;
		System.out.println("2: "+km.getKeyLabes( matrix));
		
		matrix[0] = 0;
		matrix[1] = 0;
		matrix[2] = 0x01;
		System.out.println("3: "+km.getKeyLabes( matrix));
		
		matrix[0] = 0x02;
		matrix[1] = 0;
		matrix[2] = 0;
		System.out.println("4: "+km.getKeyLabes( matrix));
		
		matrix[0] = 0;
		matrix[1] = 0x02;
		matrix[2] = 0;
		System.out.println("5: "+km.getKeyLabes( matrix));
		
		matrix[0] = 0;
		matrix[1] = 0;
		matrix[2] = 0x02;
		System.out.println("6: "+km.getKeyLabes( matrix));
		
		matrix[0] = 0;
		matrix[1] = 0;
		matrix[2] = 0;
		System.out.println("t: "+km.getKeyLabes( matrix));
	}
}
